searchNodes=[{"doc":"","ref":"Duct.html","title":"Duct","type":"module"},{"doc":"","ref":"Duct.html#run/1","title":"Duct.run/1","type":"function"},{"doc":"Base on code of Ecto.Multi in here https://github.com/elixir-ecto/ecto/blob/b0e598926180e0788b4809dffd691bd0b5b54e81/lib/ecto/multi.ex","ref":"Duct.Multi.html","title":"Duct.Multi","type":"module"},{"doc":"","ref":"Duct.Multi.html#inspect/2","title":"Duct.Multi.inspect/2","type":"function"},{"doc":"Returns an empty Duct.Multi struct. Example iex&gt; Duct.Multi . new ( ) |&gt; Duct.Multi . to_list ( ) [ ]","ref":"Duct.Multi.html#new/0","title":"Duct.Multi.new/0","type":"function"},{"doc":"Adds a function to run as part of the multi. Example Duct.Multi . new ( ) |&gt; Duct.Multi . run ( &quot;salary&quot; , fn _ -&gt; 1_000_000 end ) |&gt; Duct.Multi . run ( &quot;tax&quot; , fn %{ &quot;salary&quot; =&gt; salary } -&gt; salary * 10 / 100 end ) |&gt; Duct . run ( )","ref":"Duct.Multi.html#run/3","title":"Duct.Multi.run/3","type":"function"},{"doc":"Returns the list of operations stored in multi . Always use this function when you need to access the operations you have defined in Duct.Multi . Inspecting the Duct.Multi struct internals directly is discouraged.","ref":"Duct.Multi.html#to_list/1","title":"Duct.Multi.to_list/1","type":"function"},{"doc":"","ref":"Duct.Multi.html#t:changes/0","title":"Duct.Multi.changes/0","type":"type"},{"doc":"","ref":"Duct.Multi.html#t:name/0","title":"Duct.Multi.name/0","type":"type"},{"doc":"","ref":"Duct.Multi.html#t:run/0","title":"Duct.Multi.run/0","type":"type"},{"doc":"","ref":"Duct.Multi.html#t:t/0","title":"Duct.Multi.t/0","type":"type"},{"doc":"","ref":"Duct.Parallel.html","title":"Duct.Parallel","type":"module"},{"doc":"Returns an empty Duct.Parallel struct. Example iex&gt; Duct.Parallel . new ( ) |&gt; Duct.Parallel . to_list ( ) [ ]","ref":"Duct.Parallel.html#new/0","title":"Duct.Parallel.new/0","type":"function"},{"doc":"Adds a function to run parallel. Example Duct.Parallel . new ( ) |&gt; Duct.Parallel . run ( &quot;facebook&quot; , fn -&gt; post ( :facebook ) end ) |&gt; Duct.Parallel . run ( &quot;twitter&quot; , fn -&gt; post ( :twitter ) end ) |&gt; Duct . run ( )","ref":"Duct.Parallel.html#run/3","title":"Duct.Parallel.run/3","type":"function"},{"doc":"Returns the list of operations stored in multi . Always use this function when you need to access the operations you have defined in Duct.Multi . Inspecting the Duct.Multi struct internals directly is discouraged.","ref":"Duct.Parallel.html#to_list/1","title":"Duct.Parallel.to_list/1","type":"function"},{"doc":"","ref":"Duct.Parallel.html#yield_many/2","title":"Duct.Parallel.yield_many/2","type":"function"},{"doc":"","ref":"Duct.Parallel.html#t:name/0","title":"Duct.Parallel.name/0","type":"type"},{"doc":"","ref":"Duct.Parallel.html#t:run/0","title":"Duct.Parallel.run/0","type":"type"},{"doc":"","ref":"Duct.Parallel.html#t:t/0","title":"Duct.Parallel.t/0","type":"type"},{"doc":"A clean pipeline pattern for new Elixir project. Base on excellent Ecto.Multi data structure.","ref":"readme.html","title":"Duct","type":"extras"},{"doc":"Multi Duct.Multi . new ( ) |&gt; Duct.Multi . run ( &quot;salad&quot; , fn _ -&gt; { :ok , 10 } end ) # Return {:ok, value} or {:error, error} |&gt; Duct.Multi . run ( &quot;tomato&quot; , fn _ -&gt; 5 end ) # Default is {:ok, value} |&gt; Duct.Multi . run ( &quot;total&quot; , fn %{ &quot;salad&quot; =&gt; salad , &quot;tomato&quot; =&gt; tomato } -&gt; salad + tomato end ) |&gt; Duct.Multi . run ( &quot;tax&quot; , fn %{ &quot;total&quot; =&gt; total } -&gt; total * 0.1 end ) |&gt; Duct . run ( ) # {:ok, %{&quot;salad&quot; =&gt; 10, &quot;tomato&quot; =&gt; 5, &quot;total&quot; =&gt; 15, &quot;tax&quot; =&gt; 1.5}} Parallel Duct.Parallel . new ( ) |&gt; Duct.Parallel . run ( &quot;first&quot; , fn -&gt; Process . sleep ( 2000 ) IO . inspect ( 1 ) 1 end ) |&gt; Duct.Parallel . run ( &quot;second&quot; , fn -&gt; Process . sleep ( 1000 ) IO . inspect ( 2 ) 2 end ) |&gt; Duct . run ( ) # {:ok, %{&quot;first&quot; =&gt; 1, &quot;second&quot; =&gt; 2}}","ref":"readme.html#usage","title":"Duct - Usage","type":"extras"},{"doc":"def deps do [ { :duct , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"Duct - Installation","type":"extras"},{"doc":"Pull requests are welcome. For major changes, please open an issue first to discuss what you would like to change. Please make sure to update tests as appropriate.","ref":"readme.html#contributing","title":"Duct - Contributing","type":"extras"},{"doc":"[MIT]( https://choosealicense.com/licenses/mi","ref":"readme.html#license","title":"Duct - License","type":"extras"}]